using System;

using TeleVox_TeleToken;
using ExCommon;

namespace ExCntConfig
{
	class Class
	{
		[STAThread]
		static void Main(string[] args)
		{
			uint n;
			for (n = 0; n < GlobalDef.PASS_NO; n++)
				ZeroMem.ZeroMemory(ref GlobalDef.PassTbl[n], 16);

			string stmp;
			n = 0;
			while (n<GlobalDef.PASS_NO) {
				stmp = "Pass" + n;
				ZeroMem.StrCopy(ref GlobalDef.PassTbl[n], stmp);
				n++;
			}

			Prolog.Run();

			// zainicjowanie OutKey
			MainDef.OutKey = (MainDef.GetTickCount() & 0xFFFFFF00) | 0xF00;

			// zmiana bitw konfiguracji licznikw
			System.Console.Write("Konfigurowanie bitow licznikow:");

			n = 0;
			while (n<MainDef.TokenInfoTbl[TeleToken.TVTTTI_COUNTERS]) {
				ZeroMem.ZeroMemory(ref MainDef.OutDataA, 16);
				ZeroMem.ZeroMemory(ref MainDef.OutDataB, 16);
				ZeroMem.ZeroMemory(ref MainDef.InDataA, 16);
				ZeroMem.ZeroMemory(ref MainDef.InDataB, 16);

				MainDef.OutKey++;                                               // zwikszenie licznika kluczy

				MainDef.OutDataB[TeleToken.TVTTD_CMD] =
					TeleToken.TVTTC_CNT_SET_CONFIG;				// rozkaz konfiguracji bitw licznikw
				MainDef.OutDataB[TeleToken.TVTTD_PARAM1] = (byte) n;            // numer licznika
				MainDef.OutDataA[0] = TeleToken.TVTTCC0_WRITE |
									  TeleToken.TVTTCC0_READ |
									  TeleToken.TVTTCC0_INC_READ |
									  TeleToken.TVTTCC0_DEC_READ |
									  TeleToken.TVTTCC0_INC_ENCRYPT_READ |
									  TeleToken.TVTTCC0_STOP_AT_ZERO |
									  TeleToken.TVTTCC0_NVMEM_READ |
									  TeleToken.TVTTCC0_NVMEM_WRITE;
				MainDef.OutDataA[1] = TeleToken.TVTTCC1_PASS |
                                                      TeleToken.TVTTCC1_NVMEM_DECRYPT_WRITE |
				                      TeleToken.TVTTCC1_CONFIG_ENABLED;

				TeleToken.TVTT_Calc(MainDef.OutDataA, ref MainDef.OutDataB);    // policzenie bloku kontrolnego
				TeleToken.TVTT_CryptBlock(ref MainDef.OutDataA, MainDef.OutKey,	// zaszyfrowanie pierwszego bloku danych
					MainDef.SessionKey, TeleToken.TVTT_BLOCK_A,
					TeleToken.TVTT_PC2T);
				TeleToken.TVTT_CryptBlock(ref MainDef.OutDataB, MainDef.OutKey, // zaszyfrowanie drugiego bloku danych
					MainDef.SessionKey, TeleToken.TVTT_BLOCK_B,
					TeleToken.TVTT_PC2T);
				MainDef.Status = TeleToken.TVTT_Talk(MainDef.TokenH, 2,
					MainDef.OutKey, ref MainDef.OutDataA[0],
					ref MainDef.OutDataB[0], ref MainDef.InKey,
					ref MainDef.InDataA[0], ref MainDef.InDataB[0]);
				TeleToken.TVTT_CryptBlock(ref MainDef.InDataA, MainDef.InKey,   // rozszyfrowanie pierwszego bloku danych
					MainDef.SessionKey, TeleToken.TVTT_BLOCK_A,
					TeleToken.TVTT_T2PC);
				TeleToken.TVTT_CryptBlock(ref MainDef.InDataB, MainDef.InKey,	// rozszyfrowanie drugiego bloku danych
					MainDef.SessionKey, TeleToken.TVTT_BLOCK_B,
					TeleToken.TVTT_T2PC);

				if (MainDef.Status != 0) {
					Console.Write("\t{0:X}:{1:X02}\n", MainDef.Status>>8,
						MainDef.Status&0xFF);
					break;
				}

				if (TeleToken.TVTT_Check(MainDef.InDataA,
					ref MainDef.InDataB) != 0) {
					Console.Write("\tBlad bloku kontrolnego!\n");
					break;
				}

				if (MainDef.InDataB[TeleToken.TVTTD_STATUS] != 0) {
					Console.Write("\t{0:X}\n",
						MainDef.InDataB[TeleToken.TVTTD_STATUS]);
					break;
				}

				if (MainDef.InKey == 0) {
					Console.Write("\tWiadomosc nie zaszyfrowana!\n");	// sprawdzenie czy wiadomo zaszyfrowana
					break;
				}
				n++;
			}

			if (n >= MainDef.TokenInfoTbl[TeleToken.TVTTTI_COUNTERS])
				Console.Write("\tOK\n");

			Epilog.Run();

			return;
		}
	}
}
