using System;
using System.Windows.Forms;

using TeleVox_TeleToken;

namespace ExCommon
{
	public class GlobErr
	{
		public GlobErr()
		{
		}

		//---------------------------------------------------------------------------
		/*****************************************************************************
		Procedura wywietlajca komunikat bdu
		*****************************************************************************/
		static public void ShowErr(uint ErrNum)
		{
		  string sErr;

		  switch (ErrNum) {
			case Err.ERROR_UNEXP_NET_ERR:
			  sErr = "Nieokrelony bd";
			  break;

			case Err.ERROR_CRC:
			  sErr = "Bd bloku kontrolnego wiadomoci.";
			  break;

			case Err.ERROR_INVALID_DATA:
			  sErr = "Adres na parametr jest wyzerowany.";
			  break;

			case Err.ERROR_TOO_MANY_OPEN_FILES:
			  sErr = "Za duo otwartych TeleTokenw.";
			  break;

			case Err.ERROR_UNKNOWN_PORT:
			  sErr = "Nie znaleziono portu USB.";
			  break;

			case Err.ERROR_NOT_FOUND:
			  sErr = "TeleToken nie znaleziony.";
			  break;

			case Err.ERROR_TIMEOUT:
			  sErr = "Przekroczenie czasu trwania operacji lub sesji.";
			  break;

			case Err.ERROR_ACCOUNT_EXPIRED:
			  sErr = "Sesja nie zostaa otwarta lub wygasa.";
			  break;

			case Err.ERROR_ALREADY_INITIALIZED:
			  sErr = "Sesja jest ju otwarta.";
			  break;

			case Err.ERROR_GEN_FAILURE:
			  sErr = "TeleToken uszkodzony";
			  break;

			case Err.ERROR_NOT_SUPPORTED:
			  sErr = "Rozkaz niezaimplementowany.";
			  break;

			case Err.ERROR_INVALID_BLOCK:
			  sErr = "Adres z poza zakresu";
			  break;

			case Err.ERROR_SET_NOT_FOUND:
			  sErr = "Nie da si ustawi ochrony przed zapisem";
			  break;

			case Err.ERROR_INVALID_PASSWORD:
			  sErr = "Haso nie ma uprawnie do wykonania podanej operacji.";
			  break;

			case Err.ERROR_ACCESS_DENIED:
			  sErr = "Operacja niedozwolona (ustawiona ochrona przed zapisem, zakaz odczytu itp.)";
			  break;

			case Err.ERROR_COUNTER_TIMEOUT:
			  sErr = "Przekroczona dozwolona iloc operacji.";
			  break;

			case Err.ERROR_DLL_NOT_FOUND:
			  sErr = "Brak biblioteki TeleToken.dll";
			  break;

			default:
			  sErr = "Wystpi bd numer : " + ErrNum;
			  break;
		  }
		  MessageBox.Show(sErr, "Bd", MessageBoxButtons.OK,
		  	MessageBoxIcon.Error);
		}
		//---------------------------------------------------------------------------
		static public byte CheckErr(uint ErrNum)
		{
		  if (ErrNum != Err.ERROR_SUCCESS) {
			ShowErr(ErrNum);
			return 1;
		  }
		  return 0;
		}
		//---------------------------------------------------------------------------
	}
}
